; ##############################################################################
; ##############################################################################
; ##############################################################################
; ARG1 CTSIEN GPO2OEN PATCH XOSCEN FUNC[3:0]												
; ARG2 OPMODE[7:0]																			
;																							
; ARG1 7 CTSIEN CTS Interrupt Enable. 0 = CTS interrupt disabled. 1 = CTS interrupt enabled.
; ARG1 6 GPO2OEN GPO2 Output Enable. 0 = GPO2 output disabled. 1 = GPO2 output enabled.		
; ARG1 5 PATCH Patch Enable. 0 = Boot normally. 1 = Copy NVM to RAM, but do not boot. After CTS has been set, RAM may be patched.
; ARG1 4 XOSCEN Crystal Oscillator Enable. 0 = Use external RCLK (crystal oscillator disabled). 1 = Use crystal oscillator (RCLK and GPO3/DCLK with external 32.768 kHz crystal and OPMODE=00000101).
;!ARG1 3:0 FUNC[3:0] Function. 0 = FM Receive. 114 = Reserved. 15 = Query Library ID.										
; ARG2 7:0 OPMODE[7:0] Application Setting.										
;					00000000 = RDS output only (no audio outputs) Si4749 only	
;					00000101 = Analog audio outputs (LOUT/ROUT).				
;					00001011 = Digital audio output (DCLK, LOUT/DFS, ROUT/DIO)	
;					10110000 = Digital audio outputs (DCLK, DFS, DIO)			
SI4735_POWER_UP_FM:

	ldi temp1,(TWI_ADRESSE_RADIO)
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1	; MT-START	
	
	ldi temp1,(POWER_UP)
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; CMD		
	ldi temp1,0b00010000	; 32kHz Quarz, FM
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; ARG		
	ldi temp1,0b00000101	; Analog Output
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; ARG		

	rcall TWI_STOP								; STOPP		

	; Pause wichtig	
	rcall wait_1s
	; FM_SEEK_BAND_BOTTOM
	ldi temp1,LOW (FM_SEEK_BAND_BOTTOM)	;Property Low Byte			
	ldi temp2,HIGH(FM_SEEK_BAND_BOTTOM)	;Property High Byte			
	ldi temp3,LOW (8600)				;Property Value Low Byte	
	ldi temp4,HIGH(8600)				;Property Value High Byte	
	rcall SI4735_SET_PROPERTY_TEMP1_4
	; FM_SEEK_BAND_TOP 	
	ldi temp1,LOW (FM_SEEK_BAND_TOP)	;Property Low Byte			
	ldi temp2,HIGH(FM_SEEK_BAND_TOP)	;Property High Byte			
	ldi temp3,LOW (10800)				;Property Value Low Byte	
	ldi temp4,HIGH(10800)				;Property Value High Byte	
	rcall SI4735_SET_PROPERTY_TEMP1_4
	; FM_SEEK_FREQ_SPACING (5,10,20 default 10=100kHz)
	ldi temp1,LOW (FM_SEEK_FREQ_SPACING);Property Low Byte			
	ldi temp2,HIGH(FM_SEEK_FREQ_SPACING);Property High Byte			
	ldi temp3,LOW (10)					;Property Value Low Byte	
	ldi temp4,HIGH(10)					;Property Value High Byte	
	rcall SI4735_SET_PROPERTY_TEMP1_4
	; RX_VOLUME	(0...63 default is 63 dB)
	ldi temp1,LOW (RX_VOLUME)					;Property Low Byte			
	ldi temp2,HIGH(RX_VOLUME)					;Property High Byte			
	ldi temp3,LOW (LAUTSTAERKE_PROGRAMMSTART)	;Property Value Low Byte	
	ldi temp4,HIGH(LAUTSTAERKE_PROGRAMMSTART)	;Property Value High Byte	
	rcall SI4735_SET_PROPERTY_TEMP1_4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SI4735_FM_LAUTSTAERKE_TA:
	; TP aktiv ?						
	LDS temp,(adr_RDS_TP)
	tst temp
	breq SI4735_FM_LAUTSTAERKE_TA_NORMAL
	; TA aktiv ?						
	LDS temp,(adr_RDS_TA)
	tst temp
	brne SI4735_FM_LAUTSTAERKE_TA_LAUT
SI4735_FM_LAUTSTAERKE_TA_NORMAL:
	; RX_VOLUME	(0...63 default is 63 dB)
	ldi temp1,LOW (RX_VOLUME)					;Property Low Byte			
	ldi temp2,HIGH(RX_VOLUME)					;Property High Byte			
	ldi temp3,LOW (LAUTSTAERKE_PROGRAMMSTART)	;Property Value Low Byte	
	ldi temp4,HIGH(LAUTSTAERKE_PROGRAMMSTART)	;Property Value High Byte	
	rcall SI4735_SET_PROPERTY_TEMP1_4
	ret
SI4735_FM_LAUTSTAERKE_TA_LAUT:
	; RX_VOLUME	(0...63 default is 63 dB)
	ldi temp1,LOW (RX_VOLUME)					;Property Low Byte			
	ldi temp2,HIGH(RX_VOLUME)					;Property High Byte			
	ldi temp3,LOW (LAUTSTAERKE_TA)				;Property Value Low Byte	
	ldi temp4,HIGH(LAUTSTAERKE_TA)				;Property Value High Byte	
	rcall SI4735_SET_PROPERTY_TEMP1_4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Bit  D7 D6 D5 D4 D3 D2 D1 D0		
; CMD  0  0  1  0  0  0  1  1		
; ARG1 0  0  0  0  0  0  0  INTACK	
;									
; ARG1 0 INTACK Interrupt Acknowledge.0 = Interrupt status preserved. 1 = Clears RSQINT, BLENDINT, SNRHINT, SNRLINT, RSSIHINT, RSSILINT,MULTHINT, MULTLINT
;									
; Bit 		D7 	D6 D5 D4 D3 D2 D1 D0
; STATUS 	CTS ERR X X RSQINT RDSINT X STCINT
; RESP1 	BLENDINT X MULTHINT MULTLINT SNRHINT SNRLINT RSSIHINT RSSIILINT
; RESP2 	X X X X SMUTE X AFCRL VALID
; RESP3 	PILOT STBLEND[6:0]		
; RESP4 	RSSI[7:0]				
; RESP5 	SNR[7:0]				
; RESP6 	MULT[7:0]				
; RESP7 	FREQOFF[7:0]			
;									
; RESP1 7 BLENDINT - Blend Detect Interrupt. 0 = Blend is within the Blend threshold settings.1 = Blend goes above or below the Blend threshold settings.
; RESP1 5 MULTHINT - Multipath Detect High   0 = Detected multipath value has not exceeded above the Multipath high threshold. 1 = Detected multipath value has exceeded above the Multipath high threshold.
; RESP1 4 MULTLINT - Multipath Detect Low 0 = Detected multipath value has not fallen below the Multipath low threshold. 1 = Detected multipath value has fallen below the Multipath low threshold.
; RESP1 3 SNRHINT  - SNR Detect High.0 = Received SNR has not exceeded above SNR high threshold.1 = Received SNR has exceeded above SNR high threshold.
; RESP1 2 SNRLINT  - SNR Detect Low. 0 = Received SNR has not fallen below SNR low threshold. 1 = Received SNR has fallen below SNR low threshold.
; RESP1 1 RSSIHINT - RSSI Detect High. 0 = RSSI has not exceeded above RSSI high threshold.1 = RSSI has exceeded above RSSI high threshold.
; RESP1 0 RSSILINT - RSSI Detect Low. 0 = RSSI has not fallen below RSSI low threshold. 1 = RSSI has fallen below RSSI low threshold.
; RESP2 3 SMUTE    - Soft Mute Indicator. Indicates soft mute is engaged.														
; RESP2 1 AFCRL    - AFC Rail Indicator. Set if the AFC rails.																	
; RESP2 0 VALID    - Valid Channel. Set if the channel is currently valid and would have been found during a Seek.				
;!RESP3 7 PILOT    - Pilot Indicator. Indicates stereo pilot presence.															
;!RESP3 6:0 STBLEND- Stereo Blend Indicator. Indicates amount of stereo blend in% (100 = full stereo, 0 = full mono).			
;!RESP4 7:0 RSSI   - Received Signal Strength Indicator. Contains the current receive signal strength (0127 dBV).				
;!RESP5 7:0 SNR    - SNR. Contains the current SNR metric (0127 dB).															
; RESP6 7:0 MULT   - Multipath Contains the current multipath metric. (0 = no multipath; 100 = full multipath)					
; RESP7 7:0 FREQOFF- Frequency Offset. Signed frequency offset (kHz)															
;																																
SI4735_FM_RSQ_STATUS:
	ldi temp1,(17)
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1	; MT-START	
	ldi temp1,(FM_RSQ_STATUS)
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; CMD		
	ldi temp1,0b00000000	;  INTACK	
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; ARG		
	rcall TWI_STOP								; STOPP		
;-------------------------------------------------------------------------------
	ldi temp1,(TWI_ADRESSE_RADIO)
	rcall TWI_MASTER_RECEIVER_START_TEMP1		; MR-START	

	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; STATUS	
	STS(adr_STATUS),temp1			; STATUS	
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP1		
	STS(adr_RESP_01),temp1
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP2		
	STS(adr_RESP_02),temp1
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP3		
	STS(adr_RESP_03),temp1
	mov temp,temp1
	andi temp,0b10000000	; PILOT 		
	STS(adr_PILOT),temp
	andi temp1,0b01111111	; STBLEND[6:0]	
	STS(adr_STBLEND),temp1
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP4		
	STS(adr_RESP_04),temp1
	STS(adr_RSSI),temp1		; RSSI			
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP5		
	STS(adr_RESP_05),temp1
	STS(adr_SNR),temp1		; SNR			
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP6		
	STS(adr_RESP_06),temp1
	STS(adr_MULT),temp1		; MULT			
	rcall TWI_MASTER_RECEIVER_NO_ACK_TEMP1		; RESP7		FREQOFF
	STS(adr_RESP_07),temp1

	rcall TWI_STOP								; STOPP		

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Bit D7 D6 D5 D4 D3 D2 D1 D0		
; CMD 0 0 1 0 0 0 0 0				
; ARG1 0 0 0 0 0 0 FREEZE FAST		
; ARG2 FREQH[7:0]					
; ARG3 FREQL[7:0]					
; ARG4 ANTCAP[7:0]					
;									
; ARG1 1 FREEZE Freeze Metrics During Alternate Frequency Jump. If set will cause the blend, hicut, and softmute to transition as a function of theassociated attack/release parameters rather than instantaneously when tuning to alternate station.
; ARG1 0 FAST FAST Tuning. If set, executes fast and invalidated tune. The tune status will not be accurate.
; ARG2 7:0 FREQH[7:0] Tune Frequency High Byte. This byte in combination with FREQL selects the tune frequency in 10 kHz. In FM mode the valid range is from 6400 to 10800 (64108 MHz).
; ARG3 7:0 FREQL[7:0] Tune Frequency Low Byte. This byte in combination with FREQH selects the tune frequency in 10 kHz. In FM mode the valid range is from 6400 to 10800 (64108 MHz).
; ARG4 7:0 ANTCAP[7:0] Antenna Tuning Capacitor 										
SI4735_FM_TUNE_FREQ:
	ldi temp1,(17)
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1	; MT-START	
	ldi temp1,(FM_TUNE_FREQ)
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; CMD		
	ldi temp1,0x00000000	; FREEZE FAST
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; ARG		
	LDS temp1,(adr_FREQUENZ_SOLL_H)
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; ARG		
	LDS temp1,(adr_FREQUENZ_SOLL_L)
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; ARG		
	ldi temp1,0x00
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; ARG		
	rcall TWI_STOP
	rcall SI4735_INT_STATUS_WAIT				; wait...
	rcall SI4735_FM_TUNE_STATUS
	rcall RDS_CLEAR			; RDS clear
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CMD  	0 0 1 0 0 0 0 1															
; ARG1 	0 0 0 0 SEEKUP WRAP 0 0													
; ARG1 3 SEEKUP Seek Up/Down. Determines the direction of the search, either UP = 1, or DOWN = 0.					
; ARG1 2 WRAP Wrap/Halt. Determines whether the seek should Wrap = 1, or Halt = 0 when it hits the band limit.		
SI4735_FM_SEEK_START_UP:
	ldi temp1,(17)
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1	; MT-START	
	ldi temp1,(FM_SEEK_START)
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; CMD		
	ldi temp1,0b00001100	; SEEK-UP WRAP
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; ARG		
	rcall TWI_STOP
	rcall SI4735_INT_STATUS_WAIT				; wait...
	rcall ANZEIGE_SEARCH	
	rcall RDS_CLEAR			; RDS clear
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CMD  	0 0 1 0 0 0 0 1															
; ARG1 	0 0 0 0 SEEKUP WRAP 0 0													
; ARG1 3 SEEKUP Seek Up/Down. Determines the direction of the search, either UP = 1, or DOWN = 0.					
; ARG1 2 WRAP Wrap/Halt. Determines whether the seek should Wrap = 1, or Halt = 0 when it hits the band limit.		
SI4735_FM_SEEK_START_DOWN:
	ldi temp1,(17)
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1	; MT-START	
	ldi temp1,(FM_SEEK_START)
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; CMD		
	ldi temp1,0b00000100	; SEEK-UP WRAP
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; ARG		
	rcall TWI_STOP
	rcall SI4735_INT_STATUS_WAIT				; wait...
	rcall ANZEIGE_SEARCH
	rcall RDS_CLEAR			; RDS clear
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CMD  0 0 1 0 0 0 1 0																						
; ARG1 0 0 0 0 0 0 CANCEL INTACK																			
;																											
; ARG1 1 CANCEL Cancel seek. If set, aborts a seek currently in progress.									
; ARG1 0 INTACK Seek/Tune Interrupt Clear. If set, clears the seek/tune complete interrupt status indicator.
;																											
; Response																									
; Bit    D7   D6   D5  D4  D3     D2       D1    D0								
; STATUS CTS  ERR  X   X   RSQINT RDSINT   X     STCINT							
; RESP1  BLTF  X   X   X   X      X        AFCRL VALID							
; RESP2 READFREQH[7:0]															
; RESP3 READFREQL[7:0]															
; RESP4 RSSI[7:0]																
; RESP5 SNR[7:0]																
; RESP6 MULT[7:0]																
; RESP7 READANTCAP[7:0] (Si4704/05/06/2x only)									
;																				
; RESP1 7 BLTF Band Limit.Reports if a seek hit the band limit (WRAP = 0 in FM_START_SEEK) or wrapped to the original frequency (WRAP = 1).
; RESP1 6:2 Reserved Always returns 0.						
; RESP1 1 AFCRL AFC Rail Indicator. Set if the AFC rails.	
; RESP1 0 VALID Valid Channel.Set if the channel is currently valid as determined by the seek/tune properties(0x1403, 0x1404, 0x1108) and would have been found during a Seek.
; RESP2 7:0 READFREQH[7:0]Read Frequency High Byte.(10 kHz)	
; RESP3 7:0 READFREQL[7:0]Read Frequency Low Byte.(10 kHz)	
; RESP4 7:0 RSSI[7:0] Received Signal Strength Indicator. This byte contains the receive signal strength when tune is complete (dBV).
; RESP5 7:0 SNR[7:0] SNR. This byte contains the SNR metric when tune is complete (dB).
; RESP6 7:0 MULT[7:0] Multipath. This byte contains the multipath metric when tune is complete. Multipath indicator is available only for Si474x, Si4706-C30 and later andSi4704/05/30/31/34/35/84/85 -D50 and later.
; RESP7 7:0 READANTCAP [7:0] Read Antenna Tuning Capacitor (Si4704/05/06/2x only). This byte contains the current antenna tuning capacitor value.
SI4735_FM_TUNE_STATUS:
	ldi temp1,(TWI_ADRESSE_RADIO)
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1	; MT-START	
	ldi temp1,(FM_TUNE_STATUS)
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; CMD		
	ldi temp1,0b00000001	; CANCEL INTACK
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; ARG1		
	rcall TWI_STOP								; STOPP		
;-------------------------------------------------------------------------------
	ldi temp1,(TWI_ADRESSE_RADIO)
	rcall TWI_MASTER_RECEIVER_START_TEMP1		; MR-START	

	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; STATUS	
	STS(adr_STATUS),temp1			; STATUS	
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP1		
	STS(adr_RESP_01),temp1
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP2		
	STS(adr_RESP_02),temp1
	STS(adr_FREQUENZ_IST_H),temp1	; Frequenz (H)
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP3		
	STS(adr_RESP_03),temp1
	STS(adr_FREQUENZ_IST_L),temp1	; Frequenz (L)
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP4		
	STS(adr_RESP_04),temp1
	STS(adr_RSSI),temp1				;RSSI
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP5		
	STS(adr_RESP_05),temp1
	STS(adr_SNR),temp1				;SNR
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP6		
	STS(adr_RESP_06),temp1
	STS(adr_MULT),temp1				;MULT
	rcall TWI_MASTER_RECEIVER_NO_ACK_TEMP1		; RESP7		
	STS(adr_RESP_07),temp1

	rcall TWI_STOP								; STOPP		

	rcall SI4735_INT_STATUS_WAIT				; wait...

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

